import java.util.LinkedList;

/** Die Klasse Blatt erbt von Knoten. Ein Blatt speichert alle Actions, die es fr das Pattern gibt, das durch dieses Blatt quasi rekonstruierbar ist.<br>
 * Diese Actions werden in einer LinkedList gespeichert.
 *
 * Stand: 09.07.2001
 */
public class Blatt
    extends Knoten{

    protected LinkedList list;

    /** Ein Blatt wird immer mit einer Regel(Rule) erzeugt, da es keine leeren Bltter gibt. Der Konstruktor verlangt also nach der berbage einer Regel.
     *
     * @param newRule Regel, die in den Baum, in dieses Blatt eingefgt werden soll
     */
    public Blatt( Rule newRule ){
        list = new LinkedList();
        addAction( newRule.getAction() );
    }

    /** Im Blatt angekommen, wird aus der Regel die Action extrahiert und in das Blatt/LinkedList eingefgt.
     *
     * @param action einzufgende Regel
     */
    public void addAction( Action action ){
        list.add( action );
    }

    /** Hier wird eine Methode aus Knoten berschrieben, deshalb werden mehr Parameter angefordert als eigentlich ntig.<br>
     * Hier wird diese Methode einfach dazu verwendet die Liste der gespeicherten Actions als Action-Array zurckzugeben.
     *
     * Gendert: 12.06.2001 Action -> Action[]
     * Gendert: 25.06.2001 Es wird jetzt einfach die LinkedList zurckgegeben
     *
     * @param view Blickfeld der Ameise
     * @param positionAgent Position des Agenten
     * @return list alle fr dieses Blatt gespeicherten Actions in einer LinkedList.
     */
    public LinkedList getActionFromBlickfeld( Blickfeld view, Koord3D positionAgent )
        throws NullPointerException{      
        return list;
    }
}
