class Emerentia{
    protected static final int NUMBER_NESTS = 100;
    protected static final int NUMBER_RUNS = 100;   // Durchlufe durch den gesamten GenPool!
    protected static final int NUMBER_AGENTS = 4;
    protected static final int NUMBER_ROUNDS = 100;

    protected static final double MAXIMUM_BLOCKS = NUMBER_AGENTS * NUMBER_ROUNDS;

    protected static final int NUMBER_GENS = 15;
    protected static final double PROPABILITY = 0.0;

    public Emerentia(){
        Simulator sim = new Environment();

        sim.setNumberNests( NUMBER_NESTS );
        sim.setSizeOfNest( new Koord3D( 71,71,71 ));
        sim.setPropability( PROPABILITY );
        sim.setNumberAgents( NUMBER_AGENTS );
        sim.setResolveOfConflict(Simulator.LEAST_JOKER);
        sim.setNumberGensInGenom( NUMBER_GENS );
	sim.setSizeOfView( 3 );

        sim.setDoCrossover( true );


        sim.resetTotal();

        double[] fitnessValues = new double[NUMBER_RUNS];

        for( int run = 0; run<NUMBER_RUNS; run++){
            double sumOfFitness_currentRun = 0;

            for( int it = 0; it < run; it++){
                debug( "durchschnittliche Fitness fr Lauf #"+it+" war: "+(fitnessValues[it]/NUMBER_NESTS));
            }

            for( int i = 0; i < NUMBER_NESTS; i++){

                sim.laufeRunden(NUMBER_ROUNDS);
                //double random = (Math.random() * 100)%50 + add;

                double fitness = calculateFitness(sim);
                sim.setFitness( fitness );

                sim.nextNest();

                sumOfFitness_currentRun += fitness;
            }

            fitnessValues[run] = sumOfFitness_currentRun;
        }
    }


    protected double calculateFitness( Simulator sim ){
        // ermittle Anzahl der verwendeten Gene
        int[] array = debugGenom_and_countBlocksBuiltByGen( sim );
        int numberUsedGens = countUsedGens( array );
        int sumUsedGens = sumupUsedGens( array );

        // Anzahl der insgesamt gebauten Blcke
        double blocksBuilt = (double)sim.getNumberBuiltBlocks();

        // (Anzahl der nicht mit Gen #1 gebauten Blcke) / (Anzahl der Gene pro Genom) * (Anzahl der zum Bau verwendeten Gene - Gen #1)
        //double add = ((blocksBuilt - array[0]) / (NUMBER_GENS))*(numberUsedGens-1);
        //double add = (blocksBuilt - array[0])*(numberUsedGens-1);
        //double add = (blocksBuilt / MAXIMUM_BLOCKS) * 100 *(numberUsedGens-1);
        //double add = ((blocksBuilt - array[0])/blocksBuilt)*100;
        //double add = (blocksBuilt/MAXIMUM_BLOCKS)*((100/NUMBER_GENS)*(numberUsedGens-1));
        //double add = (blocksBuilt/MAXIMUM_BLOCKS)*((100/NUMBER_GENS)*numberUsedGens);
	double add = 0;

        // folgend die Gewichtung fr die Anzahl der insgesamt gebauten Blocks
        double base = (blocksBuilt / MAXIMUM_BLOCKS) * 100;
        //double base = 0;

        // (blocks / MAXIMUM_BLOCKS) * 100      => Belegung der Nest in Prozent
        double fitness = base  + add;


        return fitness;
    }

    protected int sumupUsedGens( int[] array ){
        int result = 0;
        for( int i=0; i<array.length;i++){
            result+=array[i];
        }

        return result;
    }

    protected int[] debugGenom_and_countBlocksBuiltByGen( Simulator sim ){
        int[] array = new int[sim.getSizeGenom()];
        for( int j = 0; j<sim.getSizeGenom(); j++){
            array[j] = sim.getHowOftenUsed_Gen(j);
            debug( "Gen "+j+" wurde "+array[j]+" Mal angewendet." );
        }

        return array;
    }

    protected int countUsedGens( int[] array ){
        int counter = 0;
        for( int in = 0; in<array.length;in++)
            if( array[in] > 0 )
                counter++;
        return counter;
    }

    protected void debug( String msg ){
        System.out.println( msg );
    }

    public static void main( String[] args ){
        new Emerentia();
    }
}
