import java.awt.*;
import javax.swing.*;
/**
 * Title: MarkViewDialog
 * Description: This dialog implements the possibility to mark honeycombs and to
 * visualize them in different ways (NIY)
 * @author Dimitri Missoh & Daniel Schlosser
 * @version 0.1
 */

public class MarkViewDialog extends javax.swing.JDialog
{
    //unsere Variablen
    Koord3D[] selektierteWaben=new Koord3D[4];
    java.awt.Color[] farben=new java.awt.Color[4];
    int wabenSwitch=-1;
    ModellViewer screen;
    boolean isVisi=false;
    private int lastSelection;
    static final int NOTHINGSELECTED=0;
    static final int POLYGON2DSELECTED=1;
    static final int AREASELECTED=2;
    static final int CUBESELECTED=3;
    static final int POLYGON3DSELECTED=4;

    //unsere Methoden
    public void honeycombGotMarked(Koord3D c){
	if(!isVisi) return;
        if(wabenSwitch!=-1)
        {
	    for(int i=0;i<4;i++)
		    if(c.equals(selektierteWaben[i]))return;
	    if(selektierteWaben[wabenSwitch]!=null)
		screen.demarkHoneycomb(selektierteWaben[wabenSwitch]);
	    selektierteWaben[wabenSwitch]=new Koord3D(c.getX(),c.getY(),c.getZ());
            screen.markHoneycomb(c,farben[wabenSwitch]);
        }
        updateButtons();
    }

    public void honeycombHasBeenRemoved(Koord3D c)
    {
	for(int i=0;i<4;i++)
	        if(c.equals(selektierteWaben[i]))
	        {
		    selektierteWaben[i]=null;
		    updateButtons();
		}
    }
    void updateButtons(){
           for(int i=0;i<4;i++)
           {
                if(selektierteWaben[i]==null)
                        WabenB[i].setText("Wabe 1: nicht belegt");
                else
                        WabenB[i].setText("Wabe 1: "+selektierteWaben[i].toString());
                Graphics g=WabenB[i].getGraphics();
                WabenB[i].update(g);
           }
    }

    public void reset()
    {
        wabenSwitch=-1;
        for(int i=0;i<4;i++)
        {
            WabenB[i].setSelected(false);
            selektierteWaben=new Koord3D[4];
        }
        this.lastSelection=NOTHINGSELECTED;
    }
    //standart Kram
	public MarkViewDialog(TheHive parent,ModellViewer screen)
	{
		super(parent);
		this.screen=screen;
		farben[0]=java.awt.Color.cyan;
		farben[1]=java.awt.Color.green;
		farben[2]=java.awt.Color.magenta;
		farben[3]=java.awt.Color.yellow;
		// This code is automatically generated by Visual Cafe when you add
		// components to the visual environment. It instantiates and initializes
		// the components. To modify the code, only use code syntax that matches
		// what Visual Cafe can generate, or Visual Cafe may be unable to back
		// parse your Java file into its visual environment.
		//{{INIT_CONTROLS
		for(int i=0;i<4;i++)
		    WabenB[i]=new JToggleButton();
		setTitle("markieren und ausblenden");
		getContentPane().setLayout(new BorderLayout(0,0));
		setSize(500,200);
		JPanel1.setLayout(new FlowLayout(FlowLayout.CENTER,5,5));
		getContentPane().add(BorderLayout.SOUTH,JPanel1);
		ausblendenB.setText("Wabe ausblenden");
		JPanel1.add(ausblendenB);
		gitterB.setText("Wabe als Gittermodell");
		JPanel1.add(gitterB);
		BackB.setText("alles zurcknehmen");
		JPanel1.add(BackB);
		JPanel3.setLayout(new GridLayout(2,1,0,0));
		getContentPane().add(JPanel3);
		JPanel2.setLayout(new GridLayout(2,2,0,0));
		JPanel3.add(JPanel2);
		JPanel2.add(WabenB[0]);
		WabenB[0].setForeground(farben[0]);
		JPanel2.add(WabenB[1]);
		WabenB[1].setForeground(farben[1]);
		JPanel2.add(WabenB[2]);
		WabenB[2].setForeground(farben[2]);
		JPanel2.add(WabenB[3]);
		WabenB[3].setForeground(farben[3]);
		JPanel4.setLayout(new GridLayout(2,2,0,0));
		JPanel3.add(JPanel4);
		polygon2DB.setText("2D Dreieck");
		JPanel4.add(polygon2DB);
		EbeneB.setText("Ebene");
		JPanel4.add(EbeneB);
		kubusB.setText("Kubus");
		JPanel4.add(kubusB);
		Polygon3DB.setText("Tetraeder");
		JPanel4.add(Polygon3DB);
		this.updateButtons();
		//}}

		//{{REGISTER_LISTENERS
		SymAction lSymAction = new SymAction();
		for(int i=0;i<4;i++)
		    WabenB[i].addActionListener(lSymAction);
		polygon2DB.addActionListener(lSymAction);
		EbeneB.addActionListener(lSymAction);
		kubusB.addActionListener(lSymAction);
		Polygon3DB.addActionListener(lSymAction);
		ausblendenB.addActionListener(lSymAction);
		gitterB.addActionListener(lSymAction);
		BackB.addActionListener(lSymAction);
                this.lastSelection=NOTHINGSELECTED;
		//}}
	}

	public void setVisible(boolean b)
	{
		if (b)
			setLocation(50, 50);
		super.setVisible(b);
		this.isVisi=b;
	}

	//{{DECLARE_CONTROLS
	javax.swing.JPanel JPanel1 = new javax.swing.JPanel();
	javax.swing.JButton ausblendenB = new javax.swing.JButton();
	javax.swing.JButton gitterB = new javax.swing.JButton();
	javax.swing.JPanel JPanel3 = new javax.swing.JPanel();
	javax.swing.JPanel JPanel2 = new javax.swing.JPanel();
	javax.swing.JPanel JPanel4 = new javax.swing.JPanel();
	javax.swing.JButton polygon2DB = new javax.swing.JButton();
	javax.swing.JButton EbeneB = new javax.swing.JButton();
	javax.swing.JButton kubusB = new javax.swing.JButton();
	javax.swing.JButton Polygon3DB = new javax.swing.JButton();
	javax.swing.JToggleButton[] WabenB=new javax.swing.JToggleButton[4];
	javax.swing.JButton BackB = new javax.swing.JButton();
	//}}


	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == WabenB[0])
				Wabe1B_actionPerformed(event);
			else if (object == WabenB[1])
				Wabe2B_actionPerformed(event);
			else if (object == WabenB[2])
				Wabe3B_actionPerformed(event);
			else if (object == WabenB[3])
				Wabe4B_actionPerformed(event);
			else if (object == polygon2DB)
				polygon2DB_actionPerformed(event);
			else if (object == EbeneB)
				EbeneB_actionPerformed(event);
			else if (object == kubusB)
				kubusB_actionPerformed(event);
			else if (object == Polygon3DB)
				Polygon3DB_actionPerformed(event);
			else if (object == ausblendenB)
				ausblendenB_actionPerformed(event);
			else if (object == gitterB)
				gitterB_actionPerformed(event);
			else if (object == BackB)
			    BackB_actionPerformed(event);
		}
	}

	void Wabe1B_actionPerformed(java.awt.event.ActionEvent event)
	{
	    if( (!WabenB[0].isSelected())&&(!WabenB[1].isSelected())&&(!WabenB[2].isSelected())&&(!WabenB[3].isSelected())  )
	        wabenSwitch=-1;
		if(WabenB[0].isSelected()){
		    for(int i=1;i<4;i++)
    		    WabenB[i].setSelected(false);
		    wabenSwitch=0;
		}

	}

	void Wabe2B_actionPerformed(java.awt.event.ActionEvent event)
	{
	    if( (!WabenB[0].isSelected())&&(!WabenB[1].isSelected())&&(!WabenB[2].isSelected())&&(!WabenB[3].isSelected())  )
	        wabenSwitch=-1;
		if(WabenB[1].isSelected()){
		    for(int i=2;i<5;i++)
    		    WabenB[i%4].setSelected(false);
            wabenSwitch=1;
		}
	}

	void Wabe3B_actionPerformed(java.awt.event.ActionEvent event)
	{
	    if( (!WabenB[0].isSelected())&&(!WabenB[1].isSelected())&&(!WabenB[2].isSelected())&&(!WabenB[3].isSelected())  )
	        wabenSwitch=-1;
		if(WabenB[2].isSelected()){
		    for(int i=3;i<6;i++)
    		    WabenB[i%4].setSelected(false);
		    wabenSwitch=2;
		}
	}

	void Wabe4B_actionPerformed(java.awt.event.ActionEvent event)
	{
	    if( (!WabenB[0].isSelected())&&(!WabenB[1].isSelected())&&(!WabenB[2].isSelected())&&(!WabenB[3].isSelected())  )
	        wabenSwitch=-1;
		if(WabenB[3].isSelected()){
		    for(int i=0;i<3;i++)
    		    WabenB[i].setSelected(false);
            wabenSwitch=3;
		}
	}

	void polygon2DB_actionPerformed(java.awt.event.ActionEvent event)
	{
		if(screen.selectPolygon2D(this.selektierteWaben))
		        this.lastSelection=this.POLYGON2DSELECTED;
	}

	void EbeneB_actionPerformed(java.awt.event.ActionEvent event)
	{
		if(screen.selectArea(this.selektierteWaben))
		    	this.lastSelection=this.AREASELECTED;
        }

	void kubusB_actionPerformed(java.awt.event.ActionEvent event)
	{
		if(screen.selectCube(this.selektierteWaben))
		    	this.lastSelection=this.CUBESELECTED;
	}

	void Polygon3DB_actionPerformed(java.awt.event.ActionEvent event)
	{
		if(screen.selectPolygon3D(this.selektierteWaben))
		    	this.lastSelection=this.POLYGON3DSELECTED;
	}

	void ausblendenB_actionPerformed(java.awt.event.ActionEvent event)
	{
		screen.selectedRemove();
	}

	void gitterB_actionPerformed(java.awt.event.ActionEvent event)
	{
		screen.selectedToLines();
	}

        void BackB_actionPerformed(java.awt.event.ActionEvent event)
        {
          screen.allTempRemovedBack();
          screen.allSolid();
        }
}